Codeforces 1066 C(思维)

传送门:

题面:

C. Books Queries

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

You have got a shelf and want to put some books on it.

You are given qq queries of three types:

  1. L idid — put a book having index idid on the shelf to the left from the leftmost existing book;
  2. R idid — put a book having index idid on the shelf to the right from the rightmost existing book;
  3. ? idid — calculate the minimum number of books you need to pop from the left or from the right in such a way that the book with index idid will be leftmost or rightmost.

You can assume that the first book you will put can have any position (it does not matter) and queries of type 33 are always valid (it is guaranteed that the book in each such query is already placed). You can also assume that you don't put the same book on the shelf twice, so idids don't repeat in queries of first two types.

Your problem is to answer all the queries of type 33 in order they appear in the input.

Note that after answering the query of type 33 all the books remain on the shelf and the relative order of books does not change.

If you are Python programmer, consider using PyPy instead of Python when you submit your code.

Input

The first line of the input contains one integer qq (1≤q≤2⋅1051≤q≤2⋅105) — the number of queries.

Then qq lines follow. The ii-th line contains the ii-th query in format as in the problem statement. It is guaranteed that queries are always valid (for query type 33, it is guaranteed that the book in each such query is already placed, and for other types, it is guaranteed that the book was not placed before).

It is guaranteed that there is at least one query of type 33 in the input.

In each query the constraint 1≤id≤2⋅1051≤id≤2⋅105 is met.

Output

Print answers to queries of the type 33 in order they appear in the input.

Examples

input

Copy

8
L 1
R 2
R 3
? 2
L 4
? 1
L 5
? 1

output

Copy

1
1
2

input

Copy

10
L 100
R 100000
R 123
L 101
? 123
L 10
R 115
? 100
R 110
? 115

output

Copy

0
2
1

Note

Let's take a look at the first example and let's consider queries:

  1. The shelf will look like [1][1];
  2. The shelf will look like [1,2][1,2];
  3. The shelf will look like [1,2,3][1,2,3];
  4. The shelf looks like [1,2,3][1,2,3] so the answer is 11;
  5. The shelf will look like [4,1,2,3][4,1,2,3];
  6. The shelf looks like [4,1,2,3][4,1,2,3] so the answer is 11;
  7. The shelf will look like [5,4,1,2,3][5,4,1,2,3];
  8. The shelf looks like [5,4,1,2,3][5,4,1,2,3] so the answer is 22.

Let's take a look at the second example and let's consider queries:

  1. The shelf will look like [100][100];
  2. The shelf will look like [100,100000][100,100000];
  3. The shelf will look like [100,100000,123][100,100000,123];
  4. The shelf will look like [101,100,100000,123][101,100,100000,123];
  5. The shelf looks like [101,100,100000,123][101,100,100000,123] so the answer is 00;
  6. The shelf will look like [10,101,100,100000,123][10,101,100,100000,123];
  7. The shelf will look like [10,101,100,100000,123,115][10,101,100,100000,123,115];
  8. The shelf looks like [10,101,100,100000,123,115][10,101,100,100000,123,115] so the answer is 22;
  9. The shelf will look like [10,101,100,100000,123,115,110][10,101,100,100000,123,115,110];
  10. The shelf looks like [10,101,100,100000,123,115,110][10,101,100,100000,123,115,110] so the answer is 11.

题意:

    有三种操作:(1)‘L’,num,将num放入最左端(2)‘R’,num,(3)‘?’,num,让你从求出最小从左边或右边去除多少个数才能取得数num。

题目分析:

    最开始想得特别复杂,认为需要模拟一个动态向两边拓展的数组,并在每一次操作(1)(2)后用线段树对现在的整个区间的[L,R]+1,最后用map记录一下最小的在哪里就好了。

    但是看到一堆人过了这个题后才意识到,题目显然没有这么复杂!!!不知道为什么会想到用所谓的线段树

    考虑到要用最小的代价将物品取出,故对于某一个物品,必定是在“?”询问前的最后一次放入的才是最优位置。因此我们只需要用数组对每个数记录一下最优解,最后分别用取(最优位置-最左端位置,以及最右端-最优位置)中的最小值即可。

代码:

#include <bits/stdc++.h>
#define maxn 400005
using namespace std;
int a[maxn];
char str[2];
int main()
{
    int t;
    scanf("%d",&t);
    int l=200000;
    int r=l-1;
    while(t--){
        int num;
        scanf("%s",str);
        scanf("%d",&num);
        if(str[0]=='L'){
            l--;
            a[num]=l;
        }
        else if(str[0]=='R'){
            r++;
            a[num]=r;
        }
        else{
            int res=min(a[num]-l,r-a[num]);
            cout<<res<<endl;
        }
    }
    return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值